const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const community_comments = sequelize.define(
    'community_comments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

body: {
        type: DataTypes.TEXT,
      
      

      },

visibility: {
        type: DataTypes.ENUM,
      
      

        values: [

"visible",


"hidden",


"removed"

        ],

      },

like_count: {
        type: DataTypes.INTEGER,
      
      

      },

published_at: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  community_comments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























    db.community_comments.hasMany(db.community_reactions, {
      as: 'community_reactions_comment',
      foreignKey: {
          name: 'commentId',
      },
      constraints: false,
    });

















//end loop



    db.community_comments.belongsTo(db.community_posts, {
      as: 'post',
      foreignKey: {
        name: 'postId',
      },
      constraints: false,
    });

    db.community_comments.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });

    db.community_comments.belongsTo(db.community_comments, {
      as: 'parent_comment',
      foreignKey: {
        name: 'parent_commentId',
      },
      constraints: false,
    });




    db.community_comments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.community_comments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return community_comments;
};


